AWS Resources

Fetch all resources belonging to the specified type in your cloud environment and list them in the response.  

Version 1 (v1)Version 1 (v1)

GET/rest/v1/resource/{resourceType}/AWS

Input ParametersInput Parameters

Parameter Mandatory/Optional Data Type Description
filter Optional String Filter the resources by providing a query using Qualys syntax.
The following search tokens are supported.
List of tokens supported for AWS resources
Note: As of TC 2.13, Resources support tags.name token for tags applied to Connector (connector tag)  and exception tag (tag applied to resources using Apply Tag API for Tag Exception creation).
pageNo Mandatory Integer The page to be returned.
pageSize Mandatory Integer The number of records per page to be included in the response.
sort Optional Keyword Sort the results using a Qualys token. Sorting is currently enabled with only one sort token: lastSyncedOn. The allowed values are asc or desc.
updated Optional String Use a date range or specific date to define when the resource was last updated.
Examples:
Show resources updated within certain dates, updated: [2021-01-01 ... 2021-03-01]
Show resources updated starting 2018-10-01, ending 1 month ago, updated: [2021-01-01 ... now-1m]
Show resources updated starting 2 weeks ago, ending 1 second ago, updated: [now-2w ... now-1s]
Show resources updated on specific date, updated: 2021-01-08
resourceType Mandatory String Select the type of resource you want to fetch inventory on.
AWS Resource Types:
EC2_INSTANCE,
LOAD_BALANCER,
VPC,
INTERNET_GATEWAY,
SUBNET,
ROUTE_TABLE,
NETWORK_ACL,
VPC_SECURITY_GROUP,
AUTO_SCALING_GROUP,
BUCKET,
IAM_USER,
BEDROCK_FOUNDATION_MODEL,
BEDROCK_CUSTOM_MODEL,
BEDROCK_KNOWLEDGE_BASES,
SAGEMAKER_MODEL,
RDS,
EBS,
LAMBDA,
EKS_CLUSTER,
EKS_NODEGROUP,
EKS_FARGATE_PROFILE,
IAM_GROUP,
IAM_POLICY,
IAM_ROLE,
VPC_ENDPOINT,
VPC_ENDPOINT_SERVICE,
SAGEMAKER_NOTEBOOK,
SECRETS,
REDSHIFT_CLUSTERS,
CLOUDFRONT_DISTRIBUTION,
ECR_REPOSITORY,
ROUTE_53_HOSTED_ZONE,
ROUTE_53_DOMAIN, 
STATE_MACHINE,
SNS_TOPIC,
EFS_FILE_SYSTEM,
ECS_CLUSTER,
SQS_QUEUE,
API_GATEWAY,
CUSTOM_DOMAIN,
NETWORK_INTERFACES

Sample - Get the list of all AWS resources by typeSample - Get the list of all AWS resources by type

API request

    
      curl -X GET -u <username>:<password>
"<qualys_base_url>/cloudview-api/rest/v1/resource/BUCKET/AWS?pageNo=0&pageSize=50"
      

JSON Response

    
      {
    "content": [
        {
            "accountAlias": "sample-XXXXXXXXXXXX",
            "controlsFailed": 6,
            "bucketName": "aws-cloudtrail-events",
            "resourceId": "aws-cloudtrail-events",
            "connectorUuids": [
                "XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX"
            ],
            "bucketCreationDateStr": "2021-02-23T00:34:11+0000",
            "created": "2022-01-05T11:20:28.200+00:00",
            "cloudAccountId": "XXXXXXXXXXXX",
            "s3GrantList": [
                {
                    "emailAddress": null,
                    "groupUri": null,
                    "displayName": null,
                    "permission": "FullControl",
                    "id": "dcf00289423844232d18c426dc98979a5d581505165de60971d8e1a891a44ef7"
                }
            ],
            "uuid": "a5ad9d67-4d1f-3ee2-b625-f3b04a237a8f",
            "connectorUuid": "XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX",
            "createdOn": "2022-01-05T11:20:28+0000",
            "tags": [],
            "remediationEnabled": null,
            "lastUpdated": "2022-01-05T11:20:28+0000",
            "ownerName": "user_john",
            "cloudType": "AWS",
            "name": "aws-cloudtrail-events",
            "bucketPolicy":
  
        
  "resourceType": "BUCKET"
        }
    ],
    "pageable": {
        "sort": {
            "sorted": false,
            "unsorted": true,
            "empty": true
        },
        "pageNumber": 0,
        "pageSize": 6,
        "offset": 0,
        "paged": true,
        "unpaged": false
    },
    "last": true,
    "totalElements": 6,
    "totalPages": 1,
    "sort": {
        "sorted": false,
        "unsorted": true,
        "empty": true
    },
    "numberOfElements": 6,
    "first": true,
    "size": 6,
    "number": 0,
    "empty": false
}
      

Version 2 (v2)Version 2 (v2)

GET/rest/v2/resource/{resourceType}/AWS

v2 is designed to efficiently handle large volumes of resource and evaluation data and to provide seamless pagination.

Key Features in v2:

  • Support for large evaluation result sets:
    The APIs now support retrieving more than 10,000 resource and evaluation records, removing the previous limit on result size.
  • Pagination using marker:
    A new response element, marker, is included in every API response. This marker allows continuation-based pagination across multiple API requests.

How this works:

  1. You can specify the size / pageSize parameter to control the number of records returned in a single response. The maximum allowable size is 1000.
  2. Each response includes a marker value.
  3. To retrieve subsequent records, you must pass the marker value from the previous response must be passed in the subsequent request.
  4. This process continues until no further marker is returned, indicating that all evaluation results have been retrieved.

Input ParametersInput Parameters

Parameter Mandatory/Optional Data Type Description
filter Optional String Filter resources using a Qualys query.
The following search tokens are supported.
List of tokens supported for AWS resources
pageSize Optional Integer The number of records per page to be included in the response.
sort Optional Keyword Sort the results using a Qualys token. Sorting is currently enabled with only one sort token: lastSyncedOn. The allowed values are asc or desc.
updated Optional String Use a date range or specific date to define when the resource was last updated.
Examples:
Show resources updated within certain dates, updated: [2021-01-01 ... 2021-03-01]
Show resources updated starting 2018-10-01, ending 1 month ago, updated: [2021-01-01 ... now-1m]
Show resources updated starting 2 weeks ago, ending 1 second ago, updated: [now-2w ... now-1s]
Show resources updated on specific date, updated: 2021-01-08
resourceType Mandatory String Select the type of resource you want to fetch inventory for.
marker Optional
(for first API call)
Mandatory
(for subsequent API calls)
Integer Use the marker value from the previous response to retrieve the next set of evaluation results.

Sample: Get the list of all AWS resources by type v2Sample: Get the list of all AWS resources by type v2

API request

    curl --location '<qualys_gateway>/cloudview-api/rest/v2/resource/EC2_INSTANCE/aws?pageSize=2' \
--header 'accept: */*' \
--header 'Authorization: Bearer <JWT_token>

Response (JSON)

 {
    "currentPageSize": 2,
    "content": [
        {
            "uuid": "xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx",
            "connectorUuid": "xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx",
            "connectorUuids": [
                "xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx"
            ],
            "region": "us-gov-west-1",
            "name": "Qualys Snapshot Scanner",
            "cloudType": "AWS",
            "createdOn": "2025-10-23T01:18:57+0000",
            "created": "2025-10-23T01:18:57.993+00:00",
            "remediationEnabled": null,
            "cloudAccountId": "399407435577",
            "accountAlias": null,
            "tags": [
                {
                    "key": "Name",
                    "value": "Qualys Snapshot Scanner"
                },
                {
                    "key": "App",
                    "value": "rgade-snapshot-scanner"
                },
                {
                    "key": "InstancePurpose",
                    "value": "Scanning"
                }
            ],
            "resourceId": "xxxxxxxxxxxx",
            "controlsFailed": 0,
            "qualysTags": null,
            "additionalDetails": null,
            "isSnapshotScanEnabled": false,
            "failedControlCids": null,
            "instanceId": "xxxxxxxxxxxx",
            "instanceState": "terminated",
            "spotInstanceRequestId": null,
            "networkInterfaceAddresses": [],
            "privateIpAddress": null,
            "secondaryPrivateIpAddress": null,
            "elasticIpAddress": null,
            "securityGroups": [],
            "resourceType": "EC2_INSTANCE",
            "instanceType": "t3.medium",
            "availabilityZone": "us-gov-west-1a",
            "imageId": "xxxxxxxxxxxx",
            "launchTime": "2025-10-23T00:29:32+0000",
            "vpcId": null,
            "subnetId": null,
            "publicDnsName": "",
            "privateDnsName": "",
            "publicIpAddress": null,
            "ipAddress": null,
            "instanceStatus": null,
            "events": null,
            "iamInstanceProfile": null,
            "vulnerabilities": null,
            "criticalityScore": null,
            "arsScore": null,
            "vulnerabilityStats": null,
            "secretStats": null,
            "secrets": null,
            "hasSecrets": null,
            "iamInstanceProfileRoleDetails": null,
            "classifications": null,
            "privateIpv6Address": null,
            "publicIpv6Address": null,
            "sev3Sev4Sev5VulnCount": 0,
            "updated": "2025-10-23T01:18:57+0000"
        },
        {
            "uuid": "xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx",
            "connectorUuid": "xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx",
            "connectorUuids": [
                "xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx"
            ],
            "region": "us-gov-west-1",
            "name": "Qualys Snapshot Scanner",
            "cloudType": "AWS",
            "createdOn": "2025-10-23T01:18:58+0000",
            "created": "2025-10-23T01:18:58.087+00:00",
            "remediationEnabled": null,
            "cloudAccountId": "xxxxxxxxxxxx",
            "accountAlias": null,
            "tags": [
                {
                    "key": "App",
                    "value": "rgade-snapshot-scanner"
                },
                {
                    "key": "Name",
                    "value": "Qualys Snapshot Scanner"
                },
                {
                    "key": "InstancePurpose",
                    "value": "Scanning"
                }
            ],
            "resourceId": "xxxxxxxxxxxx",
            "controlsFailed": 0,
            "qualysTags": null,
            "additionalDetails": null,
            "isSnapshotScanEnabled": false,
            "failedControlCids": null,
            "instanceId": "xxxxxxxxxxxx",
            "instanceState": "terminated",
            "spotInstanceRequestId": null,
            "networkInterfaceAddresses": [],
            "privateIpAddress": null,
            "secondaryPrivateIpAddress": null,
            "elasticIpAddress": null,
            "securityGroups": [],
            "resourceType": "EC2_INSTANCE",
            "instanceType": "t3.2xlarge",
            "availabilityZone": "us-gov-west-1a",
            "imageId": "xxxxxxxxxxxx",
            "launchTime": "2025-10-23T00:29:28+0000",
            "vpcId": null,
            "subnetId": null,
            "publicDnsName": "",
            "privateDnsName": "",
            "publicIpAddress": null,
            "ipAddress": null,
            "instanceStatus": null,
            "events": null,
            "iamInstanceProfile": null,
            "vulnerabilities": null,
            "criticalityScore": null,
            "arsScore": null,
            "vulnerabilityStats": null,
            "secretStats": null,
            "secrets": null,
            "hasSecrets": null,
            "iamInstanceProfileRoleDetails": null,
            "classifications": null,
            "privateIpv6Address": null,
            "publicIpv6Address": null,
            "sev3Sev4Sev5VulnCount": 0,
            "updated": "2025-10-23T01:18:58+0000"
        }
    ],
    "hasNext": true,
    "totalHits": 410,
    "hasContent": true,
    "marker": "WzE3NjExODIzMzgwODcsIjA1MzRkNDRlLTNkMDQtM2UyNy04OTYyLTU5M2E0NjVlM2JhNyJd"
}